Index: t3lib/class.t3lib_beuserauth.php
===================================================================
--- t3lib/class.t3lib_beuserauth.php	(revision 5376)
+++ t3lib/class.t3lib_beuserauth.php	(working copy)
@@ -132,6 +132,7 @@
 		'edit_wideDocument' => '0',
 		'edit_showFieldHelp' => 'icon',
 		'edit_RTE' => '1',
+		'extendedView' => '1',
 		'edit_docModuleUpload' => '1',
 		'disableCMlayers' => 0,
 		'navFrameWidth' => '',	// Default is 245 pixels
Index: typo3/sysext/setup/mod/locallang.xml
===================================================================
--- typo3/sysext/setup/mod/locallang.xml	(revision 5376)
+++ typo3/sysext/setup/mod/locallang.xml	(working copy)
@@ -77,6 +77,7 @@
 			<label index="edit_showFieldHelp_message">Display full text message</label>
 			<label index="edit_wideDocument">Wide document background</label>
 			<label index="edit_RTE">Enable Rich Text Editor (if available)</label>
+			<label index="extendedView">Enable extended View</label>
 			<label index="edit_docModuleUpload">File upload directly in Doc-module</label>
 			<label index="edit_functions">Edit</label>
 			<label index="disableCMlayers">Disable Popup Context Menus</label>
Index: typo3/sysext/setup/mod/index.php
===================================================================
--- typo3/sysext/setup/mod/index.php	(revision 5376)
+++ typo3/sysext/setup/mod/index.php	(working copy)
@@ -160,6 +160,7 @@
 				// Edit
 			$BE_USER->uc['edit_wideDocument'] = $d['edit_wideDocument'];
 			if ($GLOBALS['TYPO3_CONF_VARS']['BE']['RTEenabled'])	{ $BE_USER->uc['edit_RTE'] = $d['edit_RTE']; }
+			$BE_USER->uc['extendedView'] = $d['extendedView'];
 			$BE_USER->uc['edit_docModuleUpload'] = $d['edit_docModuleUpload'];
 			$BE_USER->uc['edit_showFieldHelp'] = $d['edit_showFieldHelp'];
 			$BE_USER->uc['disableCMlayers'] = $d['disableCMlayers'];
@@ -552,6 +553,10 @@
 					'type' => 'check',
 					'form' => '<input id="field_edit_RTE" type="checkbox" name="data[edit_RTE]"'.($BE_USER->uc['edit_RTE']?' checked="checked"':'').' />',
 				),
+				'extendedView' => array(
+					'type' => 'check',
+					'form' => '<input id="field_extendedView" type="checkbox" name="data[extendedView]" ' . ($BE_USER->uc['extendedView'] ? 'checked="checked "' : '') . ' />',
+				),
 				'edit_docModuleUpload' => array(
 					'type' => 'check',
 					'form' => '<input id="field_edit_docModuleUpload" type="checkbox" name="data[edit_docModuleUpload]"'.($BE_USER->uc['edit_docModuleUpload']?' checked="checked"':'').' />'
Index: typo3/sysext/setup/locallang_csh_mod.xml
===================================================================
--- typo3/sysext/setup/locallang_csh_mod.xml	(revision 5376)
+++ typo3/sysext/setup/locallang_csh_mod.xml	(working copy)
@@ -66,6 +66,8 @@
 			<label index="option_edit_RTE.description">If set, the Rich Text Editor in TYPO3 will be enabled for you. Normally you wouldn't want to disable this option.</label>
 			<label index="option_edit_RTE.details">A Rich Text Editor (RTE) means that a text editing field has buttons for making selected text bold, italic etc. Whether a RTE is available also depends on factors like the browser you are using and which extensions are installed. Finally RTEs are applied to only a few record fields. The most wellknown example would be the Text field of a Content Element.</label>
 			<label index="_option_edit_RTE.image">EXT:setup/cshimages/rte.png</label>
+			<label index="option_extendedView.alttitle">Enable extended View</label>
+			<label index="option_extendedView.description">This option enables additional control buttons for each record in the list module and files in the file module. It also enables additional fields in record editing forms, this option was formerly known as "Show secondary options (palettes)".</label>
 			<label index="option_edit_docModuleUpload.alttitle">Enable File Uploads in editing forms</label>
 			<label index="option_edit_docModuleUpload.description">This option will enable an &quot;Upload&quot; box for each field in TYPO3 records where you can attach a file or image. Most likely you don't want to disable this since it is usually just a nice thing to have.</label>
 			<label index="option_edit_docModuleUpload.details">If you disable the Upload box there is still the TYPO3 Element Browser left for attaching files and images.</label>
Index: typo3/class.db_list_extra.inc
===================================================================
--- typo3/class.db_list_extra.inc	(revision 5376)
+++ typo3/class.db_list_extra.inc	(working copy)
@@ -104,6 +104,8 @@
 
 	var $spaceIcon;							// space icon used for alignment
 
+	var $extendedView = FALSE;				// If true, will enable additional control buttons.
+
 		// Internal:
 	var $pageRow=array();					// Set to the page record (see writeTop())
 
@@ -438,7 +440,7 @@
 			if (!$listOnlyInSingleTableMode)	{
 				$theData = Array();
 				if (!$this->table && !$rowlist)	{
-					$theData[$titleCol] = '<img src="clear.gif" width="'.($GLOBALS['SOBE']->MOD_SETTINGS['bigControlPanel']?'230':'350').'" height="1" alt="" />';
+					$theData[$titleCol] = '<img src="clear.gif" width="' . ($this->extendedView ? '230' : '350') . '" height="1" alt="" />';
 					if (in_array('_CONTROL_',$this->fieldArray))	$theData['_CONTROL_']='';
 					if (in_array('_CLIPBOARD_',$this->fieldArray))	$theData['_CLIPBOARD_']='';
 				}
@@ -1104,7 +1106,7 @@
 		}
 
 			// If the extended control panel is enabled OR if we are seeing a single table:
-		if ($SOBE->MOD_SETTINGS['bigControlPanel'] || $this->table)	{
+		if ($this->extendedView || $this->table) {
 
 				// "Info": (All records)
 			$cells['viewBig']='<a href="#" onclick="'.htmlspecialchars('top.launchView(\''.$table.'\', \''.$row['uid'].'\'); return false;').'">'.
Index: typo3/db_list.php
===================================================================
--- typo3/db_list.php	(revision 5376)
+++ typo3/db_list.php	(working copy)
@@ -168,7 +168,6 @@
 
 			// MENU-ITEMS:
 		$this->MOD_MENU = array(
-			'bigControlPanel' => '',
 			'clipBoard' => '',
 			'localization' => ''
 		);
@@ -217,7 +216,6 @@
 		$dblist->calcPerms = $BE_USER->calcPerms($this->pageinfo);
 		$dblist->thumbs = $BE_USER->uc['thumbnailsByDefault'];
 		$dblist->returnUrl=$this->returnUrl;
-		$dblist->allFields = ($this->MOD_SETTINGS['bigControlPanel'] || $this->table) ? 1 : 0;
 		$dblist->localizationView = $this->MOD_SETTINGS['localization'];
 		$dblist->showClipboard = 1;
 		$dblist->disableSingleTableView = $this->modTSconfig['properties']['disableSingleTableView'];
@@ -231,9 +229,14 @@
 		$dblist->newWizards=$this->modTSconfig['properties']['newWizards']?1:0;
 		$dblist->pageRow = $this->pageinfo;
 		$dblist->counter++;
-		$dblist->MOD_MENU = array('bigControlPanel' => '', 'clipBoard' => '', 'localization' => '');
+		$dblist->MOD_MENU = array('clipBoard' => '', 'localization' => '');
 		$dblist->modTSconfig = $this->modTSconfig;
 
+		if ($GLOBALS['BE_USER']->uc['extendedView'] && !$GLOBALS['BE_USER']->getTSConfigVal('setup.override.extendedView.disableInListModule')) {
+			$dblist->extendedView = TRUE;
+		}
+		$dblist->allFields = ($dblist->extendedView || $this->table) ? 1 : 0;
+
 			// Clipboard is initialized:
 		$dblist->clipObj = t3lib_div::makeInstance('t3lib_clipboard');		// Start clipboard
 		$dblist->clipObj->initializeClipboard();	// Initialize - reads the clipboard content from the user session
@@ -252,7 +255,7 @@
 
 			// This flag will prevent the clipboard panel in being shown.
 			// It is set, if the clickmenu-layer is active AND the extended view is not enabled.
-		$dblist->dontShowClipControlPanels = $CLIENT['FORMSTYLE'] && !$this->MOD_SETTINGS['bigControlPanel'] && $dblist->clipObj->current=='normal' && !$BE_USER->uc['disableCMlayers'] && !$this->modTSconfig['properties']['showClipControlPanelsDespiteOfCMlayers'];
+		$dblist->dontShowClipControlPanels = $CLIENT['FORMSTYLE'] && !$dblist->extendedView && $dblist->clipObj->current=='normal' && !$BE_USER->uc['disableCMlayers'] && !$this->modTSconfig['properties']['showClipControlPanelsDespiteOfCMlayers'];
 
 
 
@@ -377,7 +380,6 @@
 					<div id="typo3-listOptions">
 						<form action="" method="post">';
 
-			$this->body.=t3lib_BEfunc::getFuncCheck($this->id,'SET[bigControlPanel]',$this->MOD_SETTINGS['bigControlPanel'],'db_list.php',($this->table?'&table='.$this->table:''),'id="checkLargeControl"').' <label for="checkLargeControl">'.$LANG->getLL('largeControl',1).'</label><br />';
 			if ($dblist->showClipboard)	{
 				$this->body.=t3lib_BEfunc::getFuncCheck($this->id,'SET[clipBoard]',$this->MOD_SETTINGS['clipBoard'],'db_list.php',($this->table?'&table='.$this->table:''),'id="checkShowClipBoard"').' <label for="checkShowClipBoard">'.$LANG->getLL('showClipBoard',1).'</label><br />';
 			}