Index: typo3/alt_doc.php
===================================================================
--- typo3/alt_doc.php	(revision 6669)
+++ typo3/alt_doc.php	(working copy)
@@ -518,7 +518,7 @@
 			$this->tceforms->doSaveFieldName = 'doSave';
 			$this->tceforms->localizationMode = t3lib_div::inList('text,media',$this->localizationMode) ? $this->localizationMode : '';	// text,media is keywords defined in TYPO3 Core API..., see "l10n_cat"
 			$this->tceforms->returnUrl = $this->R_URI;
-			$this->tceforms->palettesCollapsed = !$this->MOD_SETTINGS['showPalettes'];
+			$this->tceforms->palettesCollapsed = !$BE_USER->uc['extendedView'];
 			$this->tceforms->disableRTE = !$BE_USER->isRTE();
 			$this->tceforms->enableClickMenu = TRUE;
 			$this->tceforms->enableTabMenu = TRUE;
@@ -555,7 +555,6 @@
 				$body.= $this->tceforms->printNeededJSFunctions_top();
 				$body.= $this->compileForm($editForm);
 				$body.= $this->tceforms->printNeededJSFunctions();
-				$body.= $this->functionMenus();
 				$body.= $this->tceformMessages();
 			}
 		}
@@ -964,21 +963,7 @@
 		return $formContent;
 	}
 
-	/**
-	 * Create the checkbox buttons in the bottom of the pages.
-	 *
-	 * @return	string		HTML for function menus.
-	 */
-	function functionMenus()	{
-		global $LANG;
 
-			// Show palettes:
-		return '
-				<!-- Function menus (checkboxes for selecting options): -->
-				<br />'.t3lib_BEfunc::getFuncCheck('','SET[showPalettes]',$this->MOD_SETTINGS['showPalettes'],'alt_doc.php',t3lib_div::implodeArrayForUrl('',array_merge($this->R_URL_getvars,array('SET'=>''))),'id="checkShowPalettes"').'<label for="checkShowPalettes">'.$LANG->sL('LLL:EXT:lang/locallang_core.php:labels.showPalettes',1).'</label>';
-	}
-
-
 	/**
 	 * Create shortcut icon
 	 *
Index: typo3/sysext/cms/layout/db_layout.php
===================================================================
--- typo3/sysext/cms/layout/db_layout.php	(revision 6669)
+++ typo3/sysext/cms/layout/db_layout.php	(working copy)
@@ -808,7 +808,7 @@
 				$tceforms->backPath = $BACK_PATH;
 				$tceforms->initDefaultBEMode();
 				$tceforms->fieldOrder = $this->modTSconfig['properties']['tt_content.']['fieldOrder'];
-				$tceforms->palettesCollapsed = !$this->MOD_SETTINGS['showPalettes'];
+				$tceforms->palettesCollapsed = !$BE_USER->uc['extendedView'];
 				$tceforms->disableRTE = $this->MOD_SETTINGS['disableRTE'];
 				$tceforms->enableClickMenu = TRUE;
 
@@ -864,10 +864,6 @@
 		$h_func_b= t3lib_BEfunc::getFuncCheck($this->id,'SET[tt_content_showHidden]',$this->MOD_SETTINGS['tt_content_showHidden'],'db_layout.php','','id="checkTt_content_showHidden"').
 					'<label for="checkTt_content_showHidden">'.(!$q_count?$GLOBALS['TBE_TEMPLATE']->dfw($LANG->getLL('hiddenCE',1)):$LANG->getLL('hiddenCE',1).' ('.$q_count.')').'</label>';
 
-		$h_func_b.= '<br />'.
-					t3lib_BEfunc::getFuncCheck($this->id,'SET[showPalettes]',$this->MOD_SETTINGS['showPalettes'],'db_layout.php','','id="checkShowPalettes"').
-					'<label for="checkShowPalettes">'.$LANG->sL('LLL:EXT:lang/locallang_core.php:labels.showPalettes',1).'</label>';
-
 		if (t3lib_extMgm::isLoaded('context_help') && $BE_USER->uc['edit_showFieldHelp']!='text') {
 			$h_func_b.= '<br />'.
 						t3lib_BEfunc::getFuncCheck($this->id,'SET[showDescriptions]',$this->MOD_SETTINGS['showDescriptions'],'db_layout.php','','id="checkShowDescriptions"').
Index: typo3/sysext/setup/ext_tables.php
===================================================================
--- typo3/sysext/setup/ext_tables.php	(revision 6669)
+++ typo3/sysext/setup/ext_tables.php	(working copy)
@@ -94,6 +94,11 @@
 			'label' => 'LLL:EXT:setup/mod/locallang.xml:edit_showFieldHelp',
 			'csh' => 'edit_showFieldHelp',
 		),
+		'extendedView' => array(
+			'type' => 'check',
+			'label' => 'LLL:EXT:setup/mod/locallang.xml:extendedView',
+			'csh' => 'extendedView',
+		),
 		'titleLen' => array(
 			'type' => 'text',
 			'label' => 'LLL:EXT:setup/mod/locallang.xml:maxTitleLen',
@@ -162,7 +167,7 @@
 	),
 	'showitem' => '--div--;LLL:EXT:setup/mod/locallang.xml:personal_data,realName,email,emailMeAtLogin,password,password2,lang,
 			--div--;LLL:EXT:setup/mod/locallang.xml:opening,condensedMode,noMenuMode,startModule,thumbnailsByDefault,helpText,edit_showFieldHelp,titleLen,
-			--div--;LLL:EXT:setup/mod/locallang.xml:editFunctionsTab,edit_RTE,edit_wideDocument,edit_docModuleUpload,enableFlashUploader,resizeTextareas,resizeTextareas_MaxHeight,resizeTextareas_Flexible,disableCMlayers,copyLevels,recursiveDelete,
+			--div--;LLL:EXT:setup/mod/locallang.xml:editFunctionsTab,edit_RTE,edit_wideDocument,extendedView,edit_docModuleUpload,enableFlashUploader,resizeTextareas,resizeTextareas_MaxHeight,resizeTextareas_Flexible,disableCMlayers,copyLevels,recursiveDelete,
 			--div--;LLL:EXT:setup/mod/locallang.xml:adminFunctions,simulate,installToolEnableButton'
 
 );
Index: typo3/sysext/setup/locallang_csh_mod.xml
===================================================================
--- typo3/sysext/setup/locallang_csh_mod.xml	(revision 6669)
+++ typo3/sysext/setup/locallang_csh_mod.xml	(working copy)
@@ -66,6 +66,8 @@
 			<label index="option_edit_RTE.description">If set, the Rich Text Editor in TYPO3 will be enabled for you. Normally you wouldn't want to disable this option.</label>
 			<label index="option_edit_RTE.details">A Rich Text Editor (RTE) means that a text editing field has buttons for making selected text bold, italic etc. Whether a RTE is available also depends on factors like the browser you are using and which extensions are installed. Finally RTEs are applied to only a few record fields. The most wellknown example would be the Text field of a Content Element.</label>
 			<label index="_option_edit_RTE.image">EXT:setup/cshimages/rte.png</label>
+			<label index="option_extendedView.alttitle">Enable extended View</label>
+			<label index="option_extendedView.description">This option enables additional control buttons for each record in the list module and files in the file module. It also enables additional fields in record editing forms, this option was formerly known as "Show secondary options (palettes)".</label>			
 			<label index="option_edit_docModuleUpload.alttitle">Enable File Uploads in editing forms</label>
 			<label index="option_edit_docModuleUpload.description">This option will enable an &quot;Upload&quot; box for each field in TYPO3 records where you can attach a file or image. Most likely you don't want to disable this since it is usually just a nice thing to have.</label>
 			<label index="option_edit_docModuleUpload.details">If you disable the Upload box there is still the TYPO3 Element Browser left for attaching files and images.</label>
Index: typo3/sysext/setup/mod/locallang.xml
===================================================================
--- typo3/sysext/setup/mod/locallang.xml	(revision 6669)
+++ typo3/sysext/setup/mod/locallang.xml	(working copy)
@@ -75,6 +75,7 @@
 			<label index="edit_showFieldHelp_none">Display no help information</label>
 			<label index="edit_showFieldHelp_icon">Display help icon only</label>
 			<label index="edit_showFieldHelp_message">Display full text message</label>
+			<label index="extendedView">Enable extended View</label>
 			<label index="edit_wideDocument">Wide document background</label>
 			<label index="edit_RTE">Enable Rich Text Editor (if available)</label>
 			<label index="edit_docModuleUpload">File upload directly in Doc-module</label>